#pragma once
 
using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Diagnostics;
using namespace Extensibility;
using namespace System::Windows::Forms;
using namespace System::Runtime::InteropServices;
 
namespace AdxHT_011_VC
{
    //Add-in Express Add-in Module
    [GuidAttribute("1DA2EDC6-C90B-4C45-9A56-A8DAA7A44D08"), ProgId("AdxHT_011_VC.AddinModule")]
    __gc public class AddinModule : public AddinExpress::MSO::ADXAddinModule
    {
    public:
        AddinModule(void): AddinExpress::MSO::ADXAddinModule()
        {
            InitializeComponent();
        }
        AddinModule(System::ComponentModel::IContainer *container) : components(0)
        {
            /// <summary>
            /// Required for Windows.Forms Class Composition Designer support
            /// </summary>
 
            container->Add(this);
            InitializeComponent();
        }
 
        System::ComponentModel::IContainer* GetContainer()
        {
            return components;
        }
 
        void UninstallControls()
        {
            AddinExpress::MSO::ADXAddinModule::UninstallControls();
        }
 
        [ComRegisterFunctionAttribute]
        static void AddinRegister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        static void AddinUnregister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXUnregister(t);
        }
 
    protected:
        void Dispose(Boolean disposing)
        {
            if (disposing && components)
            {
                components->Dispose();
            }
            __super::Dispose(disposing);
        }
 
    private:
        /// <summary>
        /// Required designer variable.
        /// </summary>
        System::ComponentModel::Container *components;
 
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        void InitializeComponent(void)
        {
			// 
			// AddinModule
			// 
			this->AddinName = S"PPExample1 (VC)";
			this->Description = S"ADX OnClick add-in (VC)";
			this->SupportedApps = AddinExpress::MSO::ADXOfficeHostApp::ohaPowerPoint;

		}
	public:
		void DoClick(System::Object* AShape)
		{
			MessageBox::Show("VC Click.");
			
			if (dynamic_cast<PowerPoint::Shape*>(AShape) != 0)
			{
				MessageBox::Show(String::Concat("Your action on ", __try_cast<PowerPoint::Shape*>(AShape)->TextFrame->TextRange->Text, "..."));
				Marshal::ReleaseComObject(AShape);
			}

		}
    };
}

